#include <cmath>

#include <QLabel>
#include <QPainter>
#include <QLineEdit>

class PuzzleLetrs : public QLabel {
public:
	PuzzleLetrs(QWidget *p = 0) 
		: QLabel(p), sd(85.0), sd2(32.0)
	{
		sqrt3 = sqrt(3);
		ty = (sd-sd2)*0.5*sqrt3;
		tx = sd-sd2;
		double le_pos[7][2] = {
						{2*sd-114-sd2, sd*sqrt3-35-sd2},
	  					{2.0*sd-114.0-sd2, 35},
	  					{sd-sd2/2, 8},
			  			{114, 35}, 
						{114, sd*sqrt3-35-sd2}, 
						{sd-sd2/2, sd*sqrt3-sd2-8},
						{sd-sd2/2, sd*sqrt3/2.0-sd2/2.0}
		};

		for (int i = 0; i < 7; i++) {
			le[i] = new QLineEdit(this);
			le[i]->setMaxLength(1);
			le[i]->setAlignment(Qt::AlignHCenter);
			le[i]->resize(32,32);
			le[i]->setStyleSheet("border: none; selection-color: white;"
								 "selection-background-color: black");
			le[i]->move((int)le_pos[i][0], (int)le_pos[i][1]);
			le[i]->show();
  		}
		le[6]->setStyleSheet("background: black; color: white;"
							 "border: 2px solid black; selection-color: black;"
							 "selection-background-color: white");
		setTabOrder(le[5], le[6]);
		setTabOrder(le[6], le[0]);
		setTabOrder(le[0], le[1]);
		setTabOrder(le[1], le[2]);
		setTabOrder(le[2], le[3]);
		setTabOrder(le[3], le[4]);
		setTabOrder(le[4], le[5]);
		setMinimumSize(QSize(int(2*sd)+5, int(sd*sqrt3)+5));
		setMaximumSize(QSize(int(2*sd)+5, int(sd*sqrt3)+5));
	}

	QLineEdit* at(int i) 
	{
		if (i <= 7)
			return le[i];
		else
			return (QLineEdit*)0;
	}
private:
	void paintEvent(QPaintEvent *ev)
	{
		static const QPointF points[] = {
				QPointF(0.0, sd*0.5*sqrt3),
				QPointF(sd*0.5, 1.0),
				QPointF(sd*0.5+sd, 1.0),
				QPointF(sd*2, sd*0.5*sqrt3),
				QPointF(sd*0.5+sd, sd*sqrt3),
				QPointF(sd*0.5, sd*sqrt3)
		};
 		static const QPointF points2[] = {
			QPointF(tx + 0.0, ty + sd2*0.5*sqrt3),
			QPointF(tx + sd2*0.5, ty + 0.0),
			QPointF(tx + sd2*0.5+sd2, ty + 0.0),
			QPointF(tx + sd2*2, ty + sd2*0.5*sqrt3),
			QPointF(tx + sd2*0.5+sd2, ty + sd2*sqrt3),
			QPointF(tx + sd2*0.5, ty + sd2*sqrt3)
		};

		QPainter p(this);
		p.setRenderHints(QPainter::Antialiasing);
		p.setBrush(QBrush(Qt::white));
		p.drawPolygon(points, 6);		
		p.setBrush(QBrush(Qt::black));
		p.drawPolygon(points2, 6);		

		for (int i = 0; i < 6; i++)
			p.drawLine(QLineF(points[i], points2[i]));

		ev->accept();
	}
private:
	double sd, sd2, tx, ty;
	double sqrt3;
	QLineEdit *le[7];
};
